unit uForm1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type

  ENoMoreLines = class(Exception);

  TMemoWithIterator = class(TMemo)
  private
    FLineNo: integer;

    procedure First;
    procedure Last;
    function HasNext: boolean;
    function Next: string;
    function HasPrev: boolean;
    function Prev: string;

  public

    constructor Create(AOwner: TComponent); override;

    function ForwardCommaList: string;
    function ReverseCommaList: string;

  end;

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    Memo1: TMemoWithIterator;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1 := TMemoWithIterator.Create(Self);
  Memo1.Parent := Self;
  Memo1.Top := 8;
  Memo1.Left := 8;
  Memo1.Width := 201;
  Memo1.Height := 249;
  Memo1.Name := 'Memo1';
  Memo1.Lines.Clear;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ShowMessage(Memo1.ForwardCommaList);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ShowMessage(Memo1.ReverseCommaList);
end;

{ TMemoWithIterator }

constructor TMemoWithIterator.Create(AOwner: TComponent);
begin
  inherited;
  FLineNo := 0;
end;

procedure TMemoWithIterator.First;
begin
  FLineNo := 0;
end;

function TMemoWithIterator.ForwardCommaList: string;
begin
  Result := '';
  First;
  while HasNext do
  begin
    Result := Result + Next + ', ';
  end;
end;

function TMemoWithIterator.HasNext: boolean;
begin
  Result := FLineNo < Lines.Count;
end;

function TMemoWithIterator.HasPrev: boolean;
begin
  Result := FLineNo >= 0;
end;

procedure TMemoWithIterator.Last;
begin
  FLineNo := Lines.Count - 1;
end;

function TMemoWithIterator.Next: string;
begin
  if HasNext then
  begin
    Result := Lines.Strings[FLineNo];
    Inc(FLineNo);
  end
  else
  begin
    raise ENoMoreLines.Create('No more lines in memo box ' + Self.Name);
  end;
end;

function TMemoWithIterator.Prev: string;
begin
  if HasPrev then
  begin
    Result := Lines.Strings[FLineNo];
    Dec(FLineNo);
  end
  else
  begin
    raise ENoMoreLines.Create('No more lines in memo box ' + Self.Name);
  end;
end;

function TMemoWithIterator.ReverseCommaList: string;
begin
  Result := '';
  Last;
  while HasPrev do
  begin
    Result := Result + Prev + ', ';
  end;
end;

end.
